"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _awsSdk = _interopRequireDefault(require("aws-sdk"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _mimeTypes = _interopRequireDefault(require("mime-types"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var SortOrder = {
  ASC: 'ASC',
  DESC: 'DESC'
};

function sortFilesByDate(filesList) {
  var sortByDate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SortOrder.ASC;
  var result = filesList.sort(function (a, b) {
    if (sortByDate === SortOrder.DESC) {
      return a.lastModified.getTime() < b.lastModified.getTime();
    }

    return a.lastModified.getTime() > b.lastModified.getTime();
  });
  return result;
}

var SpacesClient = /*#__PURE__*/function () {
  function SpacesClient(endpoint, bucket) {
    var accessKeyId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
    var secretAccessKey = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
    (0, _classCallCheck2["default"])(this, SpacesClient);
    this.endpoint = endpoint;
    this.bucket = bucket;
    var options = {
      endpoint: endpoint
    };

    if (accessKeyId) {
      options.accessKeyId = accessKeyId;
    }

    if (secretAccessKey) {
      options.secretAccessKey = secretAccessKey;
    }

    this.s3client = new _awsSdk["default"].S3(options);
  }

  (0, _createClass2["default"])(SpacesClient, [{
    key: "getURL",
    value: function getURL(path) {
      return "https://".concat(this.bucket, ".").concat(this.endpoint, "/").concat(path);
    }
  }, {
    key: "getCDNURL",
    value: function getCDNURL(path) {
      var url = this.getURL(path);
      return url.replace(/digitaloceanspaces/, 'cdn.digitaloceanspaces');
    }
  }, {
    key: "isFilePublic",
    value: function () {
      var _isFilePublic = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(filePath) {
        var acl, isPublic;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.s3client.getObjectAcl({
                  Bucket: this.bucket,
                  Key: filePath
                }).promise();

              case 2:
                acl = _context.sent;
                isPublic = acl.Grants.some(function (_ref) {
                  var Grantee = _ref.Grantee,
                      Permission = _ref.Permission;
                  var isAllUsers = Grantee.URI && Grantee.URI.match(/AllUsers/);
                  var isRead = Permission === 'READ';
                  return isAllUsers && isRead;
                });
                return _context.abrupt("return", isPublic);

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function isFilePublic(_x) {
        return _isFilePublic.apply(this, arguments);
      }

      return isFilePublic;
    }()
  }, {
    key: "uploadFile",
    value: function () {
      var _uploadFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(uploadFilePath, destinationPath) {
        var permission,
            options,
            _args2 = arguments;
        return _regenerator["default"].wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                permission = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : 'private';
                options = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : {};
                _context2.next = 4;
                return this.s3client.upload(_objectSpread({
                  Bucket: this.bucket,
                  Body: _fs["default"].createReadStream(uploadFilePath),
                  Key: destinationPath,
                  ACL: permission === 'public' ? 'public-read' : permission,
                  // ContentDisposition: 'attachment',
                  ContentType: _mimeTypes["default"].lookup(uploadFilePath)
                }, options)).promise();

              case 4:
                return _context2.abrupt("return", this.getCDNURL(destinationPath));

              case 5:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function uploadFile(_x2, _x3) {
        return _uploadFile.apply(this, arguments);
      }

      return uploadFile;
    }()
  }, {
    key: "listPathObjects",
    value: function () {
      var _listPathObjects = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(path) {
        var data;
        return _regenerator["default"].wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.s3client.listObjectsV2({
                  Bucket: this.bucket,
                  Prefix: path
                }).promise();

              case 2:
                data = _context3.sent;
                return _context3.abrupt("return", data.Contents);

              case 4:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function listPathObjects(_x4) {
        return _listPathObjects.apply(this, arguments);
      }

      return listPathObjects;
    }()
    /**
     * List files at path sorting them by Last Modified date.
     * @param {String} path Path in DO Spaces to list files
     * @param {Object} options Options for the list
     * @param {('ASC'|'DESC')} options.sortByDate Sorting order 'ASC' or 'DESC'. 'ASC' is default.
     * @param {Boolean} options.pathOnly If true it will not return the complete
     * URL just the path in DO Spaces
     */

  }, {
    key: "listPathFiles",
    value: function () {
      var _listPathFiles = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(path) {
        var _this = this;

        var options,
            sortByDate,
            _options$pathOnly,
            pathOnly,
            objects,
            filesList,
            _args4 = arguments;

        return _regenerator["default"].wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                options = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {};
                sortByDate = options.sortByDate, _options$pathOnly = options.pathOnly, pathOnly = _options$pathOnly === void 0 ? false : _options$pathOnly;
                _context4.next = 4;
                return this.listPathObjects(path);

              case 4:
                objects = _context4.sent;
                filesList = objects.map(function (_ref2) {
                  var Key = _ref2.Key,
                      LastModified = _ref2.LastModified;
                  return {
                    url: pathOnly ? Key : _this.getCDNURL(Key),
                    lastModified: LastModified
                  };
                });
                return _context4.abrupt("return", sortFilesByDate(filesList, sortByDate));

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function listPathFiles(_x5) {
        return _listPathFiles.apply(this, arguments);
      }

      return listPathFiles;
    }()
  }, {
    key: "deleteObjects",
    value: function () {
      var _deleteObjects = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5(objects) {
        return _regenerator["default"].wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt("return", this.s3client.deleteObjects({
                  Bucket: this.bucket,
                  Delete: {
                    Objects: objects.map(function (object) {
                      return {
                        Key: object.Key
                      };
                    })
                  }
                }).promise());

              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function deleteObjects(_x6) {
        return _deleteObjects.apply(this, arguments);
      }

      return deleteObjects;
    }()
  }, {
    key: "deletePaths",
    value: function () {
      var _deletePaths = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(paths) {
        var objects;
        return _regenerator["default"].wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                objects = paths.map(function (path) {
                  return {
                    Key: path
                  };
                });
                return _context6.abrupt("return", this.deleteObjects(objects));

              case 2:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function deletePaths(_x7) {
        return _deletePaths.apply(this, arguments);
      }

      return deletePaths;
    }()
  }, {
    key: "deleteFile",
    value: function () {
      var _deleteFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(path) {
        return _regenerator["default"].wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt("return", this.deleteObjects([{
                  Key: path
                }]));

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function deleteFile(_x8) {
        return _deleteFile.apply(this, arguments);
      }

      return deleteFile;
    }()
  }, {
    key: "deleteFolder",
    value: function () {
      var _deleteFolder = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(folderPath) {
        var objects;
        return _regenerator["default"].wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.listPathObjects(folderPath);

              case 2:
                objects = _context8.sent;
                return _context8.abrupt("return", this.deleteObjects(objects));

              case 4:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function deleteFolder(_x9) {
        return _deleteFolder.apply(this, arguments);
      }

      return deleteFolder;
    }()
  }, {
    key: "copyFile",
    value: function () {
      var _copyFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(sourcePath, destinationPath) {
        var isSourcePublic;
        return _regenerator["default"].wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.isFilePublic(sourcePath);

              case 2:
                isSourcePublic = _context9.sent;
                return _context9.abrupt("return", this.s3client.copyObject({
                  Bucket: this.bucket,
                  CopySource: "/".concat(this.bucket, "/").concat(sourcePath),
                  Key: destinationPath,
                  ACL: isSourcePublic ? 'public-read' : 'private'
                }).promise());

              case 4:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function copyFile(_x10, _x11) {
        return _copyFile.apply(this, arguments);
      }

      return copyFile;
    }()
  }, {
    key: "downloadFile",
    value: function () {
      var _downloadFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(filePathToRead, filePathToSave) {
        var _this2 = this;

        var createDirIfNotExists,
            parentPath,
            _args10 = arguments;
        return _regenerator["default"].wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                createDirIfNotExists = _args10.length > 2 && _args10[2] !== undefined ? _args10[2] : true;

                if (!createDirIfNotExists) {
                  _context10.next = 5;
                  break;
                }

                parentPath = _path["default"].dirname(filePathToSave);
                _context10.next = 5;
                return _fs["default"].promises.mkdir(parentPath, {
                  recursive: true
                });

              case 5:
                return _context10.abrupt("return", new Promise(function (resolve, reject) {
                  var fileWriteStream = _fs["default"].createWriteStream(filePathToSave);

                  _this2.s3client.getObject({
                    Bucket: _this2.bucket,
                    Key: filePathToRead
                  }).on('error', function (error) {
                    _fs["default"].unlinkSync(filePathToSave);

                    reject(error);
                  }).createReadStream().pipe(fileWriteStream);

                  fileWriteStream.on('finish', function () {
                    resolve(filePathToSave);
                  });
                }));

              case 6:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10);
      }));

      function downloadFile(_x12, _x13) {
        return _downloadFile.apply(this, arguments);
      }

      return downloadFile;
    }()
  }]);
  return SpacesClient;
}();

var _default = SpacesClient;
exports["default"] = _default;
module.exports = exports.default;